package chain_transfer

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/haodanku"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/taobao"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/tik_tok"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/zhimeng"
	"fmt"
	"time"
	"xorm.io/xorm"
)

/***
master_id  站长id
provider  渠道
gid 商品id
uid 用户id
*/
func ChainTransfer(eg *xorm.Engine, args map[string]string) map[string]string {
	var res = make(map[string]string)
	res["url"] = ""
	res["word"] = ""
	userProfile, _ := db.UserProfileFindByID(eg, args["uid"])

	if userProfile != nil {
		args["acc_taobao_share_id"] = zhios_third_party_utils.Int64ToStr(userProfile.AccTaobaoShareId)
		if userProfile.AccJdCloudId == "" {
			userProfile.AccJdCloudId = userProfile.AccJdShareId
		}
		args["acc_jd_share_id"] = userProfile.AccJdCloudId
		args["acc_pdd_self_id"] = userProfile.AccPddSelfId
	}
	switch args["provider"] {
	case md.PVD_TB, md.PVD_TM:
		taobaoSdk, err := taobao.NewTaobaoSDK(eg, args["master_id"], args["platform"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]))
		if err != nil {
			return res
		}
		bizSceneId := "2"
		tbItemInfo, err := taobaoSdk.ItemDetailById(args["gid"], bizSceneId)
		if err != nil {
			fmt.Println("=======商品1", err)

			return res
		}
		if tbItemInfo != nil {
			args["gid"] = zhios_third_party_utils.AnyToString(tbItemInfo.ItemID)
		}
		curls, err := ConvertUrl(eg, args)
		if err != nil || curls == nil {
			return res
		}
		//调用好单库
		itemInfo, _ := haodanku.HaodankuDetail(args["gid"])
		//如果优惠券高
		if zhios_third_party_utils.StrToFloat64(itemInfo.CouponAmount) > zhios_third_party_utils.StrToFloat64(tbItemInfo.CouponAmount) && zhios_third_party_utils.StrToFloat64(itemInfo.CouponAmount) > 0 {
			curls.ShortenURL = "https://uland.taobao.com/coupon/edetail?activityId=" + itemInfo.ActivityId + "&itemId=" + args["gid"] + "&pid=" + taobaoSdk.SharePromoIdWeb + "&nowake=1"
		}
		//如果是小程序 并且没有渠道id 就用会员运营id 和推广位
		if zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]) == 0 {
			if curls.NewPid != "" {
				curls.ShortenURL = curls.ShortenURL + "&relationId=" + zhios_third_party_utils.Int64ToStr(curls.TbShareId)
			}
		} else {
			curls.ShortenURL = curls.ShortenURL + "&relationId=" + args["acc_taobao_share_id"]
		}

		if curls.TaoBaoWord == "" {
			// 生成淘口令
			taokou, err := taobaoSdk.WordCreate(curls.ShortenURL, "12345")
			if err != nil {
				taokou = new(md.TaobaoWord)
			}
			curls.TaoBaoWord = taokou.Text
		}
		res["url"] = curls.ShortenURL
		res["word"] = curls.TaoBaoWord
	case md.PVD_JDS:

	case md.PVD_TIKTOK, md.PVD_KUAISHOU:
		// 分享
		if args["provider"] == md.PVD_TIKTOK {
			args["coupon_url"] = "https://haohuo.jinritemai.com/views/product/item2?id=" + args["gid"]
		}

	case md.PVD_VIP:

	}
	if zhios_third_party_utils.InArr(args["provider"], []string{md.PVD_TB, md.PVD_TM}) == false {
		curls, err := ConvertUrl(eg, args)
		if err != nil || curls == nil {
			return res
		}
		res["url"] = curls.ShortenURL
		if args["provider"] == md.PVD_KUAISHOU {
			res["url"] = curls.NoOpenAppURL
		}
		if args["provider"] == md.PVD_TIKTOK {
			res["url"] = curls.H5Url
			if curls.Content != "" {
				res["word"] = curls.Content
			}
		}

	}
	return res
}

func ConvertUrl(eg *xorm.Engine, args map[string]string) (*md.ConvertedUrls, error) {
	var (
		err error
	)
	var urls *md.ConvertedUrls
	switch args["provider"] {
	case md.PVD_TB, md.PVD_TM:
		taobaoSdk, err := taobao.NewTaobaoSDK(eg, args["master_id"], args["platform"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]))
		if err != nil {
			return nil, err
		}
		tb := taobaoSdk
		var promoId = tb.CloudPromoIdWeb
		if promoId == "" {
			promoId = tb.SharePromoIdWeb
		}
		var promoId1 string
		var taobaoShareId1 string
		var IsWxTaobaoAuth bool
		fmt.Println(IsWxTaobaoAuth)
		if zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]) == 0 {
			if tb.AppletIsAuth == "1" {
				IsWxTaobaoAuth, taobaoShareId1, promoId1 = taobao.TaobaoRelationPid(eg, args)
				if IsWxTaobaoAuth == false {
					return nil, err
				} else {
					promoId = promoId1
				}
			}
		}
		thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
		if thirdZmAppKeyData == nil || err != nil {
			return urls, err
		}
		thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
		if thirdZmAppSecretData == nil || err != nil {
			return urls, err
		}
		urls, err = zhimeng.TaobaoConvertUrl(thirdZmAppKeyData.Val,
			thirdZmAppSecretData.Val, args["gid"], promoId, tb.UserSID, "", tb.Svc_AK)
		if urls != nil {
			if taobaoShareId1 != "" {
				urls.TbShareId = zhios_third_party_utils.StrToInt64(taobaoShareId1)
			}
			if promoId1 != "" {
				urls.NewPid = promoId1
			}
		}
	case md.PVD_JDS:
		thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
		if thirdZmAppKeyData == nil || err != nil {
			return urls, err
		}
		thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
		if thirdZmAppSecretData == nil || err != nil {
			return urls, err
		}
		// 初始化京东配置
		pid := args["acc_jd_share_id"]
		postData := make(map[string]interface{})
		postData["gid"] = args["gid"]
		postData["appkey"] = thirdZmAppKeyData.Val
		postData["secret_key"] = thirdZmAppSecretData.Val
		jdData, err := zhimeng.NewZhiMengJingDongSDK().
			SelectFunction("getgoodsinfo").
			WithArgs(postData).
			Result()
		mdData := &md.MoreDetailResponse{}
		// to struct
		couponUrl := ""
		couponPrice := ""
		err = jdData.ToStruct(mdData)
		if err == nil && mdData != nil && mdData.CouponURL != "" {
			couponUrl = mdData.CouponURL
			couponPrice = mdData.CouponPrice
		}
		urls, err = zhimeng.JDConvertUrl(
			thirdZmAppKeyData.Val,
			thirdZmAppSecretData.Val,
			args["gid"],
			pid,
			couponUrl,
			couponPrice,
			"")
	case md.PVD_TIKTOK, md.PVD_KUAISHOU:
		pid := "cloud_" + args["uid"]
		thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
		if thirdZmAppKeyData == nil || err != nil {
			return urls, err
		}
		thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
		if thirdZmAppSecretData == nil || err != nil {
			return urls, err
		}
		tikTokArgs := map[string]interface{}{
			"appkey":        thirdZmAppKeyData.Val,
			"secret_key":    thirdZmAppSecretData.Val,
			"product_url":   args["coupon_url"],
			"external_info": pid,
		}

		if args["provider"] == md.PVD_TIKTOK {
			tikTokArgs["need_qr_code"] = "0"

			tikTokBase, _ := tik_tok.Base(eg, args["master_id"], "")
			if zhios_third_party_utils.InArr(tikTokBase.AuthType, []string{"2", "3"}) {
				if time.Now().Unix() > 1670055300 {
					tikTokArgs["external_info"] = pid + "_" + args["master_id"]
				}
				urls, err = tik_tok.OwnTikTokUrl(tikTokBase, tikTokArgs)
			} else {
				tikTokArgs["external_info"] = pid + "_" + args["master_id"]
				urls, err = zhimeng.TikTokUrl(tikTokArgs)
			}

		} else if args["provider"] == md.PVD_KUAISHOU {
			tikTokArgs["gid"] = args["gid"]
			tikTokArgs["linkType"] = "101"
			tikTokArgs["genPoster"] = "0"
			tikTokArgs["external_info"] = pid + "_" + args["master_id"]
			urls, err = zhimeng.KuaiShouUrl(tikTokArgs)
		}
	case md.PVD_VIP:
		thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
		if thirdZmAppKeyData == nil || err != nil {
			return urls, err
		}
		thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
		if thirdZmAppSecretData == nil || err != nil {
			return urls, err
		}
		// 初始化vip配置
		pid := args["master_id"] + "_vip_cloud_" + args["uid"]
		openId := args["master_id"] + "_vip_" + args["uid"]
		urls, err = zhimeng.VipConvertUrl(
			thirdZmAppKeyData.Val,
			thirdZmAppSecretData.Val,
			args["gid"],
			pid,
			"", "vendoapi", openId, "1")
	case md.PVD_PDD:
		pid := args["acc_pdd_self_id"]
		thirdZmAppKeyData, err := db.SysCfgGetOne(eg, "third_zm_app_key")
		if thirdZmAppKeyData == nil || err != nil {
			return urls, err
		}
		thirdZmAppSecretData, err := db.SysCfgGetOne(eg, "third_zm_app_secret")
		if thirdZmAppSecretData == nil || err != nil {
			return urls, err
		}
		miniApp := "0"
		isShares := "2"
		urls, err = zhimeng.PDDConvertUrl(
			thirdZmAppKeyData.Val,
			thirdZmAppSecretData.Val,
			args["gid"],
			pid,
			"",
			miniApp,
			"0", isShares)
	}
	return urls, err
}
